<?php

/* This program is free software. You can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version. 
 
   Author: Max Kueng <maxkueng@users.sourceforge.net> */

require_once './config.php';

$status_path = $cfg['sawdog_status_path'];
$status_mtime = filemtime($cfg['sawdog_status_path']);
$status_offset = time() - $status_mtime;

$handle = fopen($status_path, 'r');
$contents = fread($handle, filesize($status_path));
fclose($handle);

$lines = preg_split('/(\r\r|\r|\n)/i', $contents);

$entries = array();
for ($i=0;$i<count($lines);$i++) {
	if (preg_match('/^([a-z0-9.-]+?)\s(\w+?)\s(\w+?)$/i', $lines[$i], $matches)) {
		$entries[$matches[1]][$matches[2]] = $matches[3];
	}
}
$hosts = array_keys($entries);

if ($_GET['xml'] == 'true') {
	if ($_GET['config'] == 'true') {
		$conf = array_keys($cfg);
		$out = '<rsp stat="ok" >';
		for ($i=0;$i<count($conf);$i++) {
			$out.= '<param key="'. $conf[$i] .'" value="'. $cfg[$conf[$i]] .'" />';
		}
		$out.= '</rsp>';
	} else {
		$out = '<rsp stat="ok" timestamp="'. date('Y-m-d H:i:s', time()) .'" filemtime="'. date('Y-m-d H:i:s', $status_mtime) .'" offset="'. $status_offset .'">';
		for ($i=0;$i<count($hosts);$i++) {
			$out.= '<host id="h-'. preg_replace('/[^0-9a-z]/i', '-', $hosts[$i]) .'">';
			$protocols = array_keys($entries[$hosts[$i]]);
			for ($ii=0;$ii<count($protocols);$ii++) {
				$out.= '<protocol name="'. $protocols[$ii] .'" status="'. $entries[$hosts[$i]][$protocols[$ii]] .'" />';
			}
			$out.= '</host>';
		}
		$out.= '</rsp>';
	}

	header('Content-Type: text/xml');
	header("Cache-Control: no-store, no-cache, must-revalidate");

} else {

	$out = '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >

		<head>
			<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
			<title>'.$cfg['sawdog_title'].'</title>
			<link rel="stylesheet" href="./css/styles.css" type="text/css" />
			<script src="./js/behaviour.js" type="text/javascript"></script>
			<script src="./js/prototype.js" type="text/javascript"></script>
			<script src="./js/scriptaculous.js?load=effects" type="text/javascript"></script>
			<script src="./js/sawdog.js" type="text/javascript"></script>
		</head>

		<body>

			<h1><a href="/" title="'.$cfg['sawdog_title'].'"><span>'.$cfg['sawdog_title'].'</span></a></h1>
			<p id="lastupdated">Last updated: <span>'. date('Y-m-d H:i:s') .'</span></p>
			<div id="about" style="display:'. (($_GET['about'] == 'true') ? 'block' : 'none') .';">
				<a class="close" href="'. $_SERVER['SCRIPT_NAME'] .'" title="close"><span>Close</span></a>
				<h2><span>Sawdog '. $cfg['sawdog_version'] .'</span></h2>
				<p class="license">Licensed under the GNU General Public License (GPL).</p>
				<p><strong><a href="'. $cfg['sawdog_homepage'] .'" title="">Sawdog</a></strong> (Simple Active Watch-DOG) is a suite of scripts that informs the 
				system operators of mission critical servers in the case of a failure.</p>
				<p>The Sawdog <em>web interface</em> uses several libraries for functionality and beautiful effects:</p>
				<ul>
					<li><strong><a href="http://prototype.conio.net/" title="">Prototype</a></strong> 1.5.0_rc0 (MIT-style license)</li>
					<li><strong><a href="http://script.aculo.us/" title="">scritp.aculo.us</a></strong> 1.6.2 (MIT license)</li>
					<li><strong><a href="http://tango.freedesktop.org/" title="">Tango Desktop Project</a></strong> (CC BY-SA 2.5 license)</li>
					<li><strong><a href="http://bennolan.com/behaviour/" title="">Behaviour</a></strong> 1.1 (BSD license)</li>
				</ul>
			</div>
			<p id="warning" class="warning"></p>
			<p id="error" class="error"></p>
			<div id="hosts">
	';
	
	for ($i=0;$i<count($hosts);$i++) {
		$protocols = array_keys($entries[$hosts[$i]]);

		$out.= '
				<div id="h-'. preg_replace('/[^0-9a-z]/i', '-', $hosts[$i]) .'" class="host">
					<h2>'. $hosts[$i] .'</h2>
					<ul class="protocols">
		';
		for ($ii=0;$ii<count($protocols);$ii++) {
			$out.= '
					<li id="h-'. preg_replace('/[^0-9a-z]/i', '-', $hosts[$i]) .'-'. $protocols[$ii] .'" 
					class="'. $entries[$hosts[$i]][$protocols[$ii]] .'">'. $protocols[$ii] .' 
					<span class="status"> is '. $entries[$hosts[$i]][$protocols[$ii]] .'</span></li>
			';
		}
		$out.= '
					</ul>
				</div>
		';
	}

	$out.= '
			</div>

			<div id="navigation">
				<h2>Navigation</h2>
				<ul>
					<li><a href="'. $_SERVER['SCRIPT_NAME'] .'?xml=true" title="">XML</a></li>
					<li><a id="nav-about" href="'. $_SERVER['SCRIPT_NAME'] .'?about=true" title="">About</a></li>
				</ul>
			</div>
		</body>

	</html>
	';	

}

echo $out;

?>
